#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 

//define for apSetFunction
#define ap_Set_Range			131

#define ap_Get_PdfPageCount		206



typedef long	(__stdcall *apOpen)(char *In,char *Out);
typedef void	(__stdcall *apClose)(long id);
typedef long	(__stdcall *apSetFunction)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long	(__stdcall *apGetFunction)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long	(__stdcall *apAddImage)(  long id,long position, 
											char *filename,
											long shift_lr,long shift_tb,long rotate,long layer,
											long zoomW,long zoomH,
											long action,char *link,long pageno);
typedef long	(__stdcall *apAddText)(   long id,long position, 
											char *string,
											long color,long alignment,
											long shift_lr,long shift_tb,long rotate,long layer,
											long hollow,
											long fontcode,char *fontname,long fontsize,
											long action,char *link,long pageno);

typedef long	(__stdcall *apAddLine)(	long id,long position, long width,long color,
											long shift_lr,long shift_tb,long rotate,long layer,
											long zoomW,long zoomH);


HMODULE				g_hapW=NULL;

apOpen		papOpen;
apClose		papClose;
apSetFunction	papSetFunction;
apGetFunction	papGetFunction;
apAddImage	papAddImage;
apAddText		papAddText;
apAddLine		papAddLine;

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadapWDll(void);
void	FreeapWDll();


void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL LoadapWDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"pdfstamp.dll");
	g_hapW=LoadLibrary(path);
	if(g_hapW==NULL)
		goto Failer;

	papOpen=(apOpen)GetProcAddress(g_hapW,"apOpen");
	if(papOpen==NULL)
		goto Failer;
	papClose=(apClose)GetProcAddress(g_hapW,"apClose");
	if(papClose==NULL)
		goto Failer;
	papSetFunction=(apSetFunction)GetProcAddress(g_hapW,"apSetFunction");
	if(papSetFunction==NULL)
		goto Failer;
	papGetFunction=(apGetFunction)GetProcAddress(g_hapW,"apGetFunction");
	if(papGetFunction==NULL)
		goto Failer;
	papAddImage=(apAddImage)GetProcAddress(g_hapW,"apAddImage");
	if(papAddImage==NULL)
		goto Failer;
	papAddText=(apAddText)GetProcAddress(g_hapW,"apAddText");
	if(papAddText==NULL)
		goto Failer;
	papAddLine=(apAddLine)GetProcAddress(g_hapW,"apAddLine");
	if(papAddLine==NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeapWDll(); 
	return FALSE;
}

void FreeapWDll()
{
	if(g_hapW==NULL)
		return ;
	FreeLibrary(g_hapW);
	g_hapW=NULL;
}




void main()
{
	char szPDFFile[256];
	char szImageFile[256];
	long id;

	memset(szPDFFile,0,256);
	memset(szImageFile,0,256);

	if(!LoadapWDll())
		return ;


	GetModulePath(szPDFFile,"example.pdf");
		
	//%text stamp%
	//%page header and page footer%
	//%Stamps are placed in the duplicate file, leaving the original copy unchanged%
	id=papOpen(szPDFFile,"1.pdf");
	if(id>0){
		//Get PDF file page count.
		long pagecount=papGetFunction(id,ap_Get_PdfPageCount,0,0,0,0);

		papAddText(	id, 7, 
						"\\d\\n\\t",
						255,0,
						50,-30,0,0,
						0,
						0,0,10,
						0,0,0);
		papAddText(	id, 5, 
						"Page \\P3+1 of \\c",
						255,0,
						-50,-30,0,0,
						0,
						0,0,10,
						0,0,0);
		papAddText(	id, 3, 
						"2003 adultpdf.com Inc.",
						2666666,0,
						-30,30,	0,0,
						0,
						300,0,10,
						0,0,0);
		papClose(id);
	}

	//%.Supports Font Style, Font Size, Text Modes (solid, outline), Grayscale and RGB Color (0-255 RGB color values supported) %
	//%.Top, bottom, vertical center, diagonal-top left and diagonal-bottom left. %
	//%Supports multiple line text stamps within one stamp item %	
	id=papOpen(szPDFFile,"2.pdf");
	if(id>0){
		papAddText(	id, 3, 
						"Sample File\\nLambkin",
						0,0,
						0,0,0,0,
						0,
						300,0,0,
						0,0,0);
		papAddText(	id, 6, 
						"Copyright adultpdf.com, Inc.",
						RGB(255,200,100),0,
						0,0,0,0,
						0,
						0,0,0,
						0,0,0);
		papAddText(	id, 9, 
						"www.adultpdf.com\\n Demo",
						255,0,
						0,0,-45,0,
						1,
						200,0,48,
						0,0,0);
		papClose(id);
	}

	//%.Grayscale Color (0-255 RGB color values supported) %
	//%.diagonal-top left and diagonal-bottom left. %
	//%Stamp on Top of or Underneath the original PDF document page contents %
	//Justification (when multi text)- Left, right, or center
	id=papOpen(szPDFFile,"3.pdf");
	if(id>0){
		papAddText(	id, 5, 
						"Page \\p of \\c",
						0,0,
						0,0,0,0,
						0,
						0,0,10,
						0,0,0);
		papAddText(	id, 9, 
						"www.adultpdf.com\\n Demo",
						RGB(200,200,200),18,
						0,0,-45,1,
						0,
						301,0,48,
						0,0,0);
		papClose(id);
	}

	//%Supports Font Style, Font Size, Text Modes (solid, outline), Grayscale and RGB Color (0-255 RGB color values supported) %
	//%Stamp on Underneath the original PDF document page contents %
	//%Text and Image can be stamped on any angle. Any positive or negative numbers, including decimal numbers may be used to specify an angle in degrees %
	id=papOpen(szPDFFile,"4.pdf");
	if(id>0){
		papAddText(	id, 9, 
						"www.adultpdf.com",
						RGB(200,200,200),0,
						0,0,-20,1,
						1,
						202,0,60,
						0,0,0);
		papClose(id);
	}

	//%Stamps can be placed in the exact vertical center of a page (or the exact vertical center within a individual stamping space) %
	id=papOpen(szPDFFile,"5.pdf");
	if(id>0){
		papAddText(	id, 9, 
						"www.adultpdf.com",
						RGB(255,255,0),0,
						0,0,0,0,
						0,
						101,0,48,
						0,0,0);
		papAddText(	id, 8, 
						"www.adultpdf.com",
						RGB(0,255,255),0,
						0,0,90,0,
						0,
						0,0,48,
						0,0,0);
		papAddText(	id, 4, 
						"www.adultpdf.com",
						RGB(0,255,255),0,
						0,0,-90,0,
						0,
						0,0,48,
						0,0,0);
		papClose(id);
	}

	//tridimensional effect
	id=papOpen(szPDFFile,"6.pdf");
	if(id>0){
		papAddText(	id, 9, 
						"www.adultpdf.com",
						RGB(64,64,64),0,
						1,1,45,0,
						0,
						0,0,64,
						0,0,0);
		papAddText(	id, 9, 
						"www.adultpdf.com",
						RGB(255,0,0),0,
						0,0,45,0,
						0,
						0,0,64,
						0,0,0);
		papClose(id);
	}

	//hollow tridimensional effect
	id=papOpen(szPDFFile,"7.pdf");
	if(id>0){
		papAddText(	id, 9, 
						"www.adultpdf.com",
						RGB(64,64,64),0,
						1,2,45,1,
						1,
						0,0,64,
						0,0,0);
		papAddText(	id, 9, 
						"www.adultpdf.com",
						RGB(255,0,0),0,
						0,0,45,0,
						1,
						0,0,64,
						0,0,0);
		papClose(id);
	}

	//%Supports image stamp (JPEG/TIFF images) %
	id=papOpen(szPDFFile,"8.pdf");
	if(id>0){
		papAddImage(	id, 7, 
						"logo.jpg",
						30,-30,0,0,
						0,0,
						0,0,0);
		papAddImage(	id, 3, 
						"logo.jpg",
						-30,30,0,0,
						0,0,
						0,0,0);
		papClose(id);
	}

	//% image stamp  %
	//%vertical center.%
	id=papOpen(szPDFFile,"9.pdf");
	if(id>0){
		papAddImage(	id, 4, 
						"logo.jpg",
						-10,0,90,0,
						0,0,
						0,0,0);
		papAddImage(	id, 8, 
						"logo.jpg",
						10,0,-90,0,
						0,0,
						0,0,0);
		papClose(id);
	}

	//%	Wrap text to a new line if it would otherwise be too long to fit in its margined area%
	id=papOpen(szPDFFile,"10.pdf");
	if(id>0){
		papAddText(	id, 9, 
						"Wrap text to a new line if it would otherwise be too long to fit in its margined area.",
						2666666,16,
						0,0,0,1,
						0,
						0,0,64,
						0,0,0);
		papClose(id);
	}

	//%Supports web links%
	//%Enabling you to easily position the stamp in any location on the page %
	id=papOpen(szPDFFile,"11.pdf");
	if(id>0){
		papAddText(	id, 2, 
						"Supports web links",
						RGB(255,11,0),0,
						-50,200,0,1,
						0,
						0,0,48,
						1,"http://www.adultpdf.com",0);
		papAddText(	id, 4, 
						"Enabling you to easily position the stamp\\n in any location on the page",
						RGB(255,11,22),17,
						-50,200,0,0,
						0,
						0,0,10,
						1,"http://www.adultpdf.com",0);
		papClose(id);
	}

	//%text rotate and position%
	id=papOpen(szPDFFile,"12.pdf");
	if(id>0){
		papAddText(	id, 1, 
						"adultpdf.com Inc.",
						65296,0,
						0,0,-45,0,
						0,
						0,0,48,
						0,0,0);
		papAddText(	id, 3, 
						"adultpdf.com Inc.",
						65296,0,
						0,0,45,0,
						0,
						0,0,48,
						0,0,0);
		papAddText(	id, 5, 
						"adultpdf.com Inc.",
						65296,0,
						0,0,-45,0,
						0,
						0,0,48,
						0,0,0);
		papAddText(	id, 7, 
						"adultpdf.com Inc.",
						65296,0,
						0,0,45,0,
						0,
						0,0,48,
						0,0,0);

		papClose(id);
	}

	//%image rotate and position%
	id=papOpen(szPDFFile,"13.pdf");
	if(id>0){
		papAddImage(	id, 9, 
						"logo.jpg",
						-70,-70,-45,0,
						0,0,
						0,0,0);

		papAddImage(	id, 9, 
						"logo.jpg",
						70,-70,225,0,
						0,0,
						0,0,0);
		papAddImage(	id, 9, 
						"logo.jpg",
						70,70,135,0,
						0,0,
						0,0,0);
		papAddImage(	id, 9, 
						"logo.jpg",
						-70,70,45,0,
						0,0,
						0,0,0);

		papClose(id);
	}
	
	id=papOpen(szPDFFile,"14.pdf");
	if(id>0){
		papAddText(	id, 7, 
						"adultpdf.com Inc.",
						165296,0,
						0,-100,-45,0,
						0,
						0,0,48,
						0,0,0);
		papAddText(	id, 7, 
						"adultpdf.com Inc.",
						1652962,0,
						50,-200,-45,0,
						0,
						0,0,48,
						0,0,0);
		papAddText(	id, 7, 
						"adultpdf.com Inc.",
						16529621,0,
						100,-300,-45,0,
						0,
						0,0,48,
						0,0,0);
		papAddText(	id, 7, 
						"adultpdf.com Inc.",
						165296210,0,
						150,-400,-45,0,
						0,
						0,0,48,
						0,0,0);
		papAddText(	id, 7, 
						"adultpdf.com Inc.",
						165210,0,
						200,-500,-45,0,
						0,
						0,0,48,
						0,0,0);

		papClose(id);
	}

	//%image zoom%
	id=papOpen(szPDFFile,"15.pdf");
	if(id>0){
		papAddImage(	id, 2, 
						"logo.jpg",
						80,200,-45,1,
						300,300,
						0,0,0);
		papClose(id);
	}


	//%Supports line stamp  %
	id=papOpen(szPDFFile,"16.pdf");
	if(id>0){
		papAddText(	id, 7, 
						"\\d\\n\\t",
						255,0,
						70,-50,0,0,
						0,
						0,0,10,
						0,0,0);
		papAddText(	id, 5, 
						"Page \\p of \\c ",
						255,0,
						-70,-50,0,0,
						0,
						0,0,10,
						0,0,0);
		papAddText(	id, 3, 
						"2003 adultpdf.com Inc.",
						255,0,
						-60,60,0,0,
						0,
						300,0,10,
						0,0,0);

		papAddLine(	id, 2, 1, 0,
						0,80,0,0,
						80,0);
		papAddLine(	id, 6, 1, 0,
						0,-80,0,0,
						80,0);

		papClose(id);
	}

		

	//%Supports links (web links, page link, open file, remote page link).%
	id=papOpen(szPDFFile,"17.pdf");
	if(id>0){
		
		papAddText(	id, 2, 
						"Supports web links",
						255,0,
						-50,200,15,0,
						0,
						0,0,32,
						1,"http://www.adultpdf.com",0);
		
		papAddText(	id, 4, 
						"Supports page links",
						255,0,
						-50,200,0,0,
						0,
						0,0,32,
						2,0,3);

		
		papAddImage(	id, 9, 
						"logo.jpg",
						0,0,15,1,
						0,0,
						3,"openlink.txt",0);
		
		papClose(id);
	}



	//%Set which pages to stamp on by selecting a predefined range.%
	//%	Eap even page%
	id=papOpen(szPDFFile,"18.pdf");
	if(id>0){
		//%	Eap even page%
		papSetFunction(id, ap_Set_Range, -2, -2, 0,0);
 
		papAddText(	id, 2, 
						"Set which pages to stamp on by selecting a predefined range.",
						2666666,17,
						0,200,0,0,
						0,
						0,0,32,
						0,0,0);
		papClose(id);
	}



	FreeapWDll();
}

